function theta_hat = bayes_blinex(x, PARAMS)
    THETA_HAT_MMSE = mmse(x, PARAMS.VARIANCE); % use MMSE estimator output as starting values
    
    warning off % to avoid warning about Trust-Region method
    theta_hat = zeros(size(x));
    for k = 1:length(x)
        if ~mod(k,10),disp(k),end
        theta_hat_blinex = fminunc(@(theta_hat) optim_wrapper(theta_hat, x(k)), ...
                              THETA_HAT_MMSE(k), optimset('Display','off'));
        theta_hat(k) = theta_hat_blinex;
    end
    warning on
    
function br = optim_wrapper(theta_hat, xk)
    br = quad(@(theta) quad_wrapper(theta, theta_hat, xk), 0, 1, 1e-4);
end

function ploss = quad_wrapper(theta, theta_hat, xk)
    ploss = blinex_loss(theta_hat,theta,PARAMS) ...
             .* 1/sqrt(2*pi*PARAMS.VARIANCE) .* exp(-1/2/PARAMS.VARIANCE*(xk-theta).^2);
end

end