function theta_hat = bayes_linex(x, PARAMS)
    ARG1 = (1 + PARAMS.A*PARAMS.VARIANCE - x)./sqrt(2*PARAMS.VARIANCE);
    ARG2 = (PARAMS.A*PARAMS.VARIANCE - x)./sqrt(2*PARAMS.VARIANCE);
    ARG3 = x/sqrt(2*PARAMS.VARIANCE);
    ARG4 = (x-1)/sqrt(2*PARAMS.VARIANCE);

    theta_hat = x - PARAMS.A*PARAMS.VARIANCE./2 ...
        - 1./PARAMS.A .* log((erf(ARG1) - erf(ARG2))./(erf(ARG3)-erf(ARG4)));

    % due to numerical problems, we have to check for inf/nan values
    INDICES = isinf(theta_hat) | isnan(theta_hat);
    theta_hat(INDICES & x < 0) = 0;
    theta_hat(INDICES & x > 1) = 1;    
end