function [LOSS, GRADIENT_LOSS] = blinex_loss(THETA_HAT, THETA, PARAMS)
% calculates the univariate blinex_loss

DELTA = THETA_HAT - THETA;
LOSS = 1/PARAMS.RHO * ( 1 - 1 ./ (1 + PARAMS.RHO * PARAMS.B * (exp(PARAMS.A*DELTA) - PARAMS.A*DELTA - 1) ) );

if nargout>1
    GRADIENT_LOSS = ( PARAMS.A*PARAMS.B*exp(PARAMS.A*DELTA) - PARAMS.A*PARAMS.B) ./ (1 + PARAMS.B * (exp(PARAMS.A*DELTA) - PARAMS.A*DELTA - 1) ).^2;
end

end
