addpath('../estimator_family_toolbox')
clc
clear


load('FAMILY_PARAMS_2011-05-11~09-10-01-114.mat') % loads estimation model setting
                                                  % and optimal parameters

ITERATIONS = 10000;                                                  
                                                  
FPARAMS_LINEX.XI1 = 0;
FPARAMS_LINEX.XI2 = 0;
FPARAMS_LINEX.XI3 = 1;
FPARAMS_LINEX.LAMBDA = 1;
FPARAMS_LINEX.PHI = -1/PARAMS.A;
FPARAMS_LINEX.PSI = -PARAMS.A;


SAMPLES = jointpdf_samples(ITERATIONS,PARAMS);
[APOSTPDF_SAMPLES,LOG_APOSTPDF_VALS] = apostpdf_samples(SAMPLES.X, NUM_APOSTPDF_SAMPLES, PARAMS);

THETA_HAT_MAP = map(SAMPLES.X);
THETA_HAT_MMSE = mmse(SAMPLES.X, PARAMS.VARIANCE);
THETA_HAT_BLINEX = bayes_blinex(SAMPLES.X, PARAMS);
THETA_HAT_FAMILY_BLINEX = estimator_family(APOSTPDF_SAMPLES, LOG_APOSTPDF_VALS, FPARAMS, LEARNING_PARAMS);
THETA_HAT_FAMILY_LINEX = estimator_family(APOSTPDF_SAMPLES, LOG_APOSTPDF_VALS, FPARAMS_LINEX, LEARNING_PARAMS);
THETA_HAT_LINEX = bayes_linex(SAMPLES.X, PARAMS);

fprintf('\n\n\tMAP\tMMSE\tOBE_BLINEX\tBLINEX_FAMILY\tLINEX (ANALYTIC)\tLINEX (FAMILY)\n')

MSE = mean([squared_loss(THETA_HAT_MAP,SAMPLES.THETA)' squared_loss(THETA_HAT_MMSE,SAMPLES.THETA)' ...
            squared_loss(THETA_HAT_BLINEX,SAMPLES.THETA)' squared_loss(THETA_HAT_FAMILY_BLINEX,SAMPLES.THETA)' ...
            squared_loss(THETA_HAT_LINEX,SAMPLES.THETA)' squared_loss(THETA_HAT_FAMILY_LINEX,SAMPLES.THETA)'],1)
BLINEX = mean([blinex_loss(THETA_HAT_MAP,SAMPLES.THETA,PARAMS)' blinex_loss(THETA_HAT_MMSE,SAMPLES.THETA,PARAMS)' ...
               blinex_loss(THETA_HAT_BLINEX,SAMPLES.THETA,PARAMS)' blinex_loss(THETA_HAT_FAMILY_BLINEX,SAMPLES.THETA,PARAMS)' ...
               blinex_loss(THETA_HAT_LINEX,SAMPLES.THETA,PARAMS)' blinex_loss(THETA_HAT_FAMILY_LINEX,SAMPLES.THETA,PARAMS)'],1)
save('RESULTS.mat')

%% make plot
% x = linspace(-0.7,0.7,2000);
% figure(1)
% width =  5.0;
% height = 4.0;
% set(gcf, 'PaperUnits', 'inches');
% set(gcf, 'PaperSize', [width height]);
% set(gcf, 'PaperPositionMode', 'manual');
% set(gcf, 'PaperPosition', [0 0 width height]);
% plot(x,blinex_loss(x,0,PARAMS),'k','LineWidth',1.2)
% hold on
% plot(x,linex_loss(x,0,PARAMS),'r--','LineWidth',1.2)
% hold off
% grid on
% xlabel('DELTA')
% ylabel('BLINEX')
% set(gca,'YScale','log')
% ylim([1e-2 1e2])
% xlim([min(x) max(x)])
% legend('BLINEXLOSS','LINEXLOSS','location','NorthWest')
% % set(gca,'YTickMode','manual')
% print('-depsc','BLINEX_LOSS')
