clc
clear

addpath('../estimator_family_toolbox')
setenv('OMP_NUM_THREADS', '2');

PARAMS.VARIANCE = 0.25;
PARAMS.RHO = 0.5;
PARAMS.A = 10;
PARAMS.B = 1;

LEARNING_PARAMS.DEBUG = 0;
LEARNING_PARAMS.TOLERANCES = 1e-8;
LEARNING_PARAMS.MaxIter = 1500;
LEARNING_PARAMS.MaxFunEvals = 1500;
LEARNING_PARAMS.UNIFORM = 0;
LEARNING_PARAMS.USE_GRADIENT = 1;
LEARNING_PARAMS.CHECK_EF_GRADIENT = 0;
LEARNING_PARAMS.CHECK_LEF_GRADIENT = 0;



NUM_JOINTPDF_SAMPLES = 5000; % corresponds to K1
NUM_APOSTPDF_SAMPLES = 5000; % corresponds to K2

START{1}.XI1 = 1;
START{1}.XI2 = 1;
START{1}.XI3 = 0;
START{1}.LAMBDA = 1;
START{1}.PHI = 0;
START{1}.PSI = 1;

START{2}.XI1 = 0.9;
START{2}.XI2 = 0.9;
START{2}.XI3 = 0.1;
START{2}.LAMBDA = 4;
START{2}.PHI = 0.1;
START{2}.PSI = 0.9;

START{3}.XI1 = 0;
START{3}.XI2 = 0;
START{3}.XI3 = 1;
START{3}.LAMBDA = 1;
START{3}.PHI = -1/PARAMS.A;
START{3}.PSI = -PARAMS.A;

JOINTPDF_SAMPLES = jointpdf_samples(NUM_JOINTPDF_SAMPLES, PARAMS); % for averaging the loss
[APOSTPDF_SAMPLES,LOG_APOSTPDF_VALS] = apostpdf_samples(JOINTPDF_SAMPLES.X, NUM_APOSTPDF_SAMPLES, PARAMS); % for calculating the estimate

FVAL = zeros(numel(START),1);
FPARAMS_ = cell(numel(START),1);

TOTAL_ITER = 50;%numel(START)*(1 + 10);
for k = 1:TOTAL_ITER
    disp(k)
    if k <= numel(START)
        LEARNING_PARAMS.FPARAMS_START = START{k};
    else
        LEARNING_PARAMS.FPARAMS_START = vect2struct(struct2vect(START{mod(k,numel(START))+1}) + [0.1 0.1 0.1 3 0.01 0.01]'.*randn(6,1));
    end
    tic
    [FPARAMS_{k},FVAL(k)] = learn_estimator_family(JOINTPDF_SAMPLES, @(THETA_HAT,THETA) blinex_loss(THETA_HAT,THETA,PARAMS), APOSTPDF_SAMPLES, LOG_APOSTPDF_VALS, LEARNING_PARAMS);
    toc
end

[V,I] = min(FVAL);
FPARAMS = FPARAMS_{I};
clear JOINTPDF_SAMPLES APOSTPDF_SAMPLES LOG_APOSTPDF_VALS
save(sprintf('FAMILY_PARAMS_%s.mat', datestr(now, 'yyyy-mm-dd~HH-MM-SS-FFF')))
