clc
addpath('../estimator_family_toolbox')

NUM_APOSTPDF_SAMPLES = 2000;
PARAMS.VARIANCE = 0.1;
ITERS = 2000;

THETA = rand(1,ITERS);
X = THETA + sqrt(PARAMS.VARIANCE)*randn(size(THETA));

FPARAMS.LAMBDA1 = 0;
FPARAMS.LAMBDA2 = 0;
FPARAMS.LAMBDA3 = 1;
FPARAMS.PSI = 1;
FPARAMS.PHI = 1;
APOSTPDF_SAMPLES = apostpdf_samples(X, NUM_APOSTPDF_SAMPLES, PARAMS);

THETA_HAT = estimator_family(X, APOSTPDF_SAMPLES, @(THETA,X) jointpdf(THETA,X,PARAMS),FPARAMS);
MSE = mean((THETA-THETA_HAT).^2);