% generate sample from truncated Gaussian
%
% Algorithm taken from
%
%   C. P. Robert: "Simulation of truncated normal variables",
%   Statistics and Computing, volume 5, number 2, pages 121-125, 1995

function sample = trunc_gaussian(mu_minus,mu_plus,mu,variance)

not_found_sample = 1;

mu_minus = (mu_minus - mu)/sqrt(variance);
mu_plus = (mu_plus - mu)/sqrt(variance);

while not_found_sample
    z = rand(1,1) * (mu_plus - mu_minus) + mu_minus;
    if mu_plus < 0
        rho = exp(1/2*(mu_plus^2 - z^2));
    elseif mu_minus > 0
        rho = exp(1/2*(mu_minus^2 - z^2));
    else
        rho = exp(-1/2*z^2);
    end
    if rand(1,1) <= rho
        sample = z;
        not_found_sample = 0;
    end
end

sample = sqrt(variance) * sample + mu;

end